CON

	sys_clk = (50000000 * 16 / 5) / 2

	_clkmode = xtal1 + pll16x
	_clkfreq =  80_000_000

''P1V - Pin assignments
''                                 +------------+
''            "HEX00"  PIN_C14  --[| PB0    PA0 |]-- PIN_V10  "GPIO_00"
''            "HEX01"  PIN_E15  --[| PB1    PA1 |]-- PIN_W10  "GPIO_01"
''            "HEX02"  PIN_C15  --[| PB2    PA2 |]-- PIN_V9   "GPIO_02"
''            "HEX03"  PIN_C16  --[| PB3    PA3 |]-- PIN_W9   "GPIO_03"
''            "HEX04"  PIN_E16  --[| PB4    PA4 |]-- PIN_V8   "GPIO_04"
''            "HEX05"  PIN_D17  --[| PB5    PA5 |]-- PIN_V7   "GPIO_06"
''            "HEX06"  PIN_C17  --[| PB6    PA6 |]-- PIN_W6   "GPIO_08"
''            "HEX07"  PIN_D15  --[| PB7    PA7 |]-- PIN_W5   "GPIO_10"
''            "HEX10"  PIN_C18  --[| PB8    PA8 |]-- PIN_AA15 "GPIO_11"
''            "HEX11"  PIN_D18  --[| PB9    PA9 |]-- PIN_AA14 "GPIO_12"
''            "HEX12"  PIN_E18  --[| PB10  PA10 |]-- PIN_W13  "GPIO_13"
''            "HEX13"  PIN_B16  --[| PB11  PA11 |]-- PIN_W12  "GPIO_14"
''            "HEX14"  PIN_A17  --[| PB12  PA12 |]-- PIN_AB13 "GPIO_15"
''            "HEX15"  PIN_A18  --[| PB13  PA13 |]-- PIN_AB12 "GPIO_16"
''            "HEX16"  PIN_B17  --[| PB14  PA14 |]-- PIN_Y11  "GPIO_17"
''            "HEX17"  PIN_A16  --[| PB15  PA15 |]-- PIN_AB11 "GPIO_18"
''            "HEX20"  PIN_B20  --[| PB16  PA16 |]-- PIN_W11  "GPIO_19"
''            "HEX21"  PIN_A20  --[| PB17  PA17 |]-- PIN_AB10 "GPIO_20"
''            "HEX22"  PIN_B19  --[| PB18  PA18 |]-- PIN_AA10 "GPIO_21"
''            "HEX23"  PIN_A21  --[| PB19  PA19 |]-- PIN_AA9  "GPIO_22"
''            "HEX24"  PIN_B21  --[| PB20  PA20 |]-- PIN_Y8   "GPIO_23"
''            "HEX25"  PIN_C22  --[| PB21  PA21 |]-- PIN_AA8  "GPIO_24"
''            "HEX26"  PIN_B22  --[| PB22  PA22 |]-- PIN_Y7   "GPIO_25"
''            "HEX27"  PIN_A19  --[| PB23  PA23 |]-- PIN_AA7  "GPIO_26"
''            "HEX30"  PIN_F21  --[| PB24  PA24 |]-- PIN_Y6   "GPIO_27"
''            "HEX31"  PIN_E22  --[| PB25  PA25 |]-- PIN_AA6  "GPIO_28"
''            "HEX32"  PIN_E21  --[| PB26  PA26 |]-- PIN_Y5   "GPIO_29"
''            "HEX33"  PIN_C19  --[| PB27  PA27 |]-- PIN_AA5  "GPIO_30"
''            "HEX34"  PIN_C20  --[| PB28  PA28 |]-- PIN_Y4   "GPIO_31"
''            "HEX35"  PIN_D19  --[| PB29  PA29 |]-- PIN_AB3  "GPIO_32"
''            "HEX36"  PIN_E17  --[| PB30  PA30 |]-- PIN_W8   "GPIO_05"
''            "HEX37"  PIN_D22  --[| PB31  PA31 |]-- PIN_W7   "GPIO_07"
''                                 +------------+
	'PortA pin assignments
	GPIO_00         = 0     'PIN_V10
	GPIO_01         = 1     'PIN_W10
	GPIO_02         = 2     'PIN_V9
	GPIO_03         = 3     'PIN_W9
	GPIO_04         = 4     'PIN_V8
	GPIO_06         = 5     'PIN_V7
	GPIO_08         = 6     'PIN_W6
	GPIO_10         = 7     'PIN_W5
	GPIO_11         = 8     'PIN_AA15
	GPIO_12         = 9     'PIN_AA14
	GPIO_13         = 10    'PIN_W13
	GPIO_14         = 11    'PIN_W12
	GPIO_15         = 12    'PIN_AB13
	GPIO_16         = 13    'PIN_AB12
	GPIO_17         = 14    'PIN_Y11
	GPIO_18         = 15    'PIN_AB11
	GPIO_19         = 16    'PIN_W11
	GPIO_20         = 17    'PIN_AB10
	GPIO_21         = 18    'PIN_AA10
	GPIO_22         = 19    'PIN_AA9
	GPIO_23         = 20    'PIN_Y8
	GPIO_24         = 21    'PIN_AA8
	GPIO_25         = 22    'PIN_Y7
	GPIO_26         = 23    'PIN_AA7
	GPIO_27         = 24    'PIN_Y6
	GPIO_28         = 25    'PIN_AA6
	GPIO_29         = 26    'PIN_Y5
	GPIO_30         = 27    'PIN_AA5
	GPIO_31         = 28    'PIN_Y4
	GPIO_32         = 29    'PIN_AB3
	GPIO_05         = 30    'PIN_W8
	GPIO_07         = 31    'PIN_W7

	'PortB pin assignments
	HEX00           = 32    'PIN_C14
	HEX01           = 33    'PIN_E15
	HEX02           = 34    'PIN_C15
	HEX03           = 35    'PIN_C16
	HEX04           = 36    'PIN_E16
	HEX05           = 37    'PIN_D17
	HEX06           = 38    'PIN_C17
	HEX07           = 39    'PIN_D15
	HEX10           = 40    'PIN_C18
	HEX11           = 41    'PIN_D18
	HEX12           = 42    'PIN_E18
	HEX13           = 43    'PIN_B16
	HEX14           = 44    'PIN_A17
	HEX15           = 45    'PIN_A18
	HEX16           = 46    'PIN_B17
	HEX17           = 47    'PIN_A16
	HEX20           = 48    'PIN_B20
	HEX21           = 49    'PIN_A20
	HEX22           = 50    'PIN_B19
	HEX23           = 51    'PIN_A21
	HEX24           = 52    'PIN_B21
	HEX25           = 53    'PIN_C22
	HEX26           = 54    'PIN_B22
	HEX27           = 55    'PIN_A19
	HEX30           = 56    'PIN_F21
	HEX31           = 57    'PIN_E22
	HEX32           = 58    'PIN_E21
	HEX33           = 59    'PIN_C19
	HEX34           = 60    'PIN_C20
	HEX35           = 61    'PIN_D19
	HEX36           = 62    'PIN_E17
	HEX37           = 63    'PIN_D22

	'Cog LEDs (n/a)
	LEDR0           = 0     'PIN_A8
	LEDR1           = 1     'PIN_A9
	LEDR2           = 2     'PIN_A10
	LEDR3           = 3     'PIN_B10
	LEDR4           = 4     'PIN_D13
	LEDR5           = 5     'PIN_C13
	LEDR6           = 6     'PIN_E14
	LEDR7           = 7     'PIN_D14
	GPIO_09         = 1001  'PIN_V5


PUB id_pins|i,pin,s,x,b,t

  i~
  repeat
    pin := byte[@list][i++]
    if pin == $ff
       i~
    else
      s := get_label(pin)
      repeat strsize(s)
        if pin > 31
          dirb[pin]~~
        else
          dira[pin]~~
        b := (byte[s++] | $100) << 1
        t := cnt
        repeat 10
          t += constant(sys_clk / 19200)
          waitcnt(t)
          if pin > 31
           outb[pin] := b & 1
          else
           outa[pin] := b & 1
          b >>=1
       
pub get_label(g): q

    q:= @pin_labels
    repeat
        ifnot byte[q++]
            ifnot g--
                return

DAT

pin_labels	byte	0
		byte	"P0-GPIO_00",0
		byte	"P1-GPIO_01",0
		byte	"P2-GPIO_02",0
		byte	"P3-GPIO_03",0
		byte	"P4-GPIO_04",0
		byte	"P5-GPIO_06",0
		byte	"P6-GPIO_08",0
		byte	"P7-GPIO_10",0
		byte	"P8-GPIO_11",0
		byte	"P9-GPIO_12",0
		byte	"P10-GPIO_13",0
		byte	"P11-GPIO_14",0
		byte	"P12-GPIO_15",0
		byte	"P13-GPIO_16",0
		byte	"P14-GPIO_17",0
		byte	"P15-GPIO_18",0
		byte	"P16-GPIO_19",0
		byte	"P17-GPIO_20",0
		byte	"P18-GPIO_21",0
		byte	"P19-GPIO_22",0
		byte	"P20-GPIO_23",0
		byte	"P21-GPIO_24",0
		byte	"P22-GPIO_25",0
		byte	"P23-GPIO_26",0
		byte	"P24-GPIO_27",0
		byte	"P25-GPIO_28",0
		byte	"P26-GPIO_29",0
		byte	"P27-GPIO_30",0
		byte	"P28-GPIO_31",0
		byte	"P29-GPIO_32",0
		byte	"P30-GPIO_05",0
		byte	"P31-GPIO_07",0
		byte	"P32-HEX00",0
		byte	"P33-HEX01",0
		byte	"P34-HEX02",0
		byte	"P35-HEX03",0
		byte	"P36-HEX04",0
		byte	"P37-HEX05",0
		byte	"P38-HEX06",0
		byte	"P39-HEX07",0
		byte	"P40-HEX10",0
		byte	"P41-HEX11",0
		byte	"P42-HEX12",0
		byte	"P43-HEX13",0
		byte	"P44-HEX14",0
		byte	"P45-HEX15",0
		byte	"P46-HEX16",0
		byte	"P47-HEX17",0
		byte	"P48-HEX20",0
		byte	"P49-HEX21",0
		byte	"P50-HEX22",0
		byte	"P51-HEX23",0
		byte	"P52-HEX24",0
		byte	"P53-HEX25",0
		byte	"P54-HEX26",0
		byte	"P55-HEX27",0
		byte	"P56-HEX30",0
		byte	"P57-HEX31",0
		byte	"P58-HEX32",0
		byte	"P59-HEX33",0
		byte	"P60-HEX34",0
		byte	"P61-HEX35",0
		byte	"P62-HEX36",0
		byte	"P63-HEX37",0


test_list
		byte	GPIO_00
		byte	GPIO_01
		byte	GPIO_02
		byte	GPIO_03
		byte	GPIO_04
		byte	GPIO_06
		byte	GPIO_08
		byte	GPIO_10
		byte	GPIO_11
		byte	GPIO_12
		byte	GPIO_13
		byte	GPIO_14
		byte	GPIO_15
		byte	GPIO_16
		byte	GPIO_17
		byte	GPIO_18
		byte	GPIO_19
		byte	GPIO_20
		byte	GPIO_21
		byte	GPIO_22
		byte	GPIO_23
		byte	GPIO_24
		byte	GPIO_25
		byte	GPIO_26
		byte	GPIO_27
		byte	GPIO_28
		byte	GPIO_29
		byte	GPIO_30
		byte	GPIO_31
		byte	GPIO_32
		byte	GPIO_05
		byte	GPIO_07
		byte	HEX00
		byte	HEX01
		byte	HEX02
		byte	HEX03
		byte	HEX04
		byte	HEX05
		byte	HEX06
		byte	HEX07
		byte	HEX10
		byte	HEX11
		byte	HEX12
		byte	HEX13
		byte	HEX14
		byte	HEX15
		byte	HEX16
		byte	HEX17
		byte	HEX20
		byte	HEX21
		byte	HEX22
		byte	HEX23
		byte	HEX24
		byte	HEX25
		byte	HEX26
		byte	HEX27
		byte	HEX30
		byte	HEX31
		byte	HEX32
		byte	HEX33
		byte	HEX34
		byte	HEX35
		byte	HEX36
		byte	HEX37
		byte	LEDR0
		byte	LEDR1
		byte	LEDR2
		byte	LEDR3
		byte	LEDR4
		byte	LEDR5
		byte	LEDR6
		byte	LEDR7
		byte	GPIO_09
		byte	$ff
